<!DOCTYPE html>
<html>
  <head>
    <title>Task 25.40</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  </head>

  <body onload="onPageLoading()">
    <div class="container jumbotron">
      <div class="col-12">
        <div class="text-center mb-5"><h1>Create Order</h1></div>
        <div class="form-group row">
          <label for="" class="col-sm-2 col-form-label">Cỡ Combo</label>
          <div class="col-sm-4">
            <select id="select-size" class="form-control">
              <option>Chọn cỡ Combo (Combo size)</option>
              <option value="S">Nhỏ</option>
              <option value="M">Vừa</option>
              <option value="L">Lớn</option>
            </select>
          </div>
          <label for="" class="col-sm-2 col-form-label">Đồ uống</label>
          <div class="col-sm-4">
            <select class="form-control" id="select-drink">
              <option>Chọn đồ uống</option>
            </select>
          </div>
        </div>
        <div class="form-group row">
          <label class="col-sm-2 col-form-label">Mã voucher</label>
          <div class="col-sm-4">
            <input
              id="inp-ma-voucher"
              type="text"
              class="form-control"
              placeholder="Voucher ID (mã voucher)"
            />
          </div>
          <label class="col-sm-2 col-form-label">Loại pizza</label>
          <div class="col-sm-4">
            <select id="select-pizza" class="form-control">
              <!-- select chưa có id, các option chưa có value-->
              <option>Chọn loại pizza</option>
              <option value="Seafood">Hải sản</option>
              <option value="Hawaii">Ha wai</option>
              <option value="Bacon">Thịt hun khói</option>
            </select>
          </div>
        </div>
        <div class="form-group row">
          <label class="col-sm-2 col-form-label" for="">Họ và tên</label>
          <div class="col-sm-4">
            <input
              id="inp-hoten"
              type="text"
              class="form-control"
              placeholder="Họ và tên"
            />
          </div>
          <label for="" class="col-sm-2 col-form-label">Email</label>
          <div class="col-sm-4">
            <input
              id="inp-email"
              type="email"
              class="form-control"
              placeholder="Email"
            />
          </div>
        </div>
        <div class="form-group row">
          <label class="col-sm-2 col-form-label">Số điện thoại</label>
          <div class="col-sm-4">
            <input
              id="inp-so-dien-thoai"
              type="text"
              class="form-control"
              placeholder="Số điện thoại"
            />
          </div>
          <label class="col-sm-2 col-form-label">Địa chỉ</label>
          <div class="col-sm-4">
            <input
              id="inp-dia-chi"
              type="text"
              class="form-control"
              placeholder="Địa chỉ"
            />
          </div>
        </div>
        <div class="form-group">
          <label>Lời nhắn</label>
          <textarea
            id="inp-loi-nhan"
            class="form-control h-75"
            placeholder="Lời nhắn"
          ></textarea>
        </div>
        <div class="form-group">
          <button class="btn btn-primary" onclick="onBtnCreateOrderClick()">
            Create Order
          </button>
          <button
            class="btn btn-secondary"
            id="btn-show"
            onclick="onBtnShowOrder()"
          >
            Show Order Data in New Form
          </button>
        </div>
      </div>
    </div>
    <script>
      "use strict";
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      const gREQUEST_STATUS_OK = 200;
      const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
      const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/";
      const gUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";
      // const vBASE_URL =
      //   "http://203.171.20.210:8080/devcamp-pizza365/voucher_detail";

      /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      function onPageLoading() {
        // load dữ liệu vào select car
        loadDataDrinkList();
      }

      function onBtnCreateOrderClick() {
        var vObjOrder = {
          kichCo: "",
          duongKinh: "",
          suon: "",
          salad: "",
          thanhTien: "",
          soLuongNuoc: "",
          idVourcher: "",
          hoTen: "",
          soDienThoai: "",
          loiNhan: "",
          idLoaiNuocUong: "",
          loaiPizza: "",
          email: "",
          diaChi: "",
        };

        var vXmlHttp = new XMLHttpRequest();
        thuThapThongTin(vObjOrder);
        comBo(vObjOrder);
        console.log(vObjOrder);
        var vCheck = kiemTraThongTin(vObjOrder);
        var vShow = document.getElementById("btn-show");
        if (vCheck) {
          kiemTraIdVourcher(vObjOrder, vXmlHttp);
          goiApiCreateOrder(vObjOrder, vXmlHttp);

          vXmlHttp.onreadystatechange = function () {
            if (
              vXmlHttp.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
              vXmlHttp.status == 201
            ) {
              console.log(vXmlHttp.responseText);
              var vOrderObj = JSON.parse(vXmlHttp.responseText);
              vShow.setAttribute("data-ordercode", vOrderObj.orderCode);
            }
          };
        }
      }
      function onBtnShowOrder() {
        var vShow = document.getElementById("btn-show");
        console.log("abc:" + vShow.dataset.ordercode);
        var vOrderCode = vShow.dataset.ordercode;
        var vLink = "OrderDetail25.40.html";
        var linkObj = vLink + "?ordercode=" + vOrderCode;
        window.location.href = linkObj;

        // vShow.addEventListener("click", function () {
        //   console.log("hello");
        //   // var vLink = "OrderDetail25.40.html";
        //   // var linkObj = vLink + "?ordercode=" + orderCode;
        // });
      }
      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      // Hàm thực hiện call api để load dữ liệu vào drink list
      function loadDataDrinkList() {
        var vXhttp = new XMLHttpRequest();
        vXhttp.open(
          "GET",
          "http://203.171.20.210:8080/devcamp-pizza365/drinks",
          true
        );
        vXhttp.send();
        vXhttp.onreadystatechange = function () {
          if (
            this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
            this.status == gREQUEST_STATUS_OK
          ) {
            console.log(vXhttp.responseText); // ghi response text ra console.log
            handleLoadDataToSelectDrink(vXhttp);
          }
        };
      }

      // handle data load to select drink
      function handleLoadDataToSelectDrink(paramXhttp) {
        var vArrayDrinkList = JSON.parse(paramXhttp.responseText);
        console.log("array drink list = " + vArrayDrinkList.length);
        //load data to drink select
        var vElementSelectDrink = document.getElementById("select-drink");
        for (
          var bIterator = 0;
          bIterator < vArrayDrinkList.length;
          bIterator++
        ) {
          var vDrinkOptionElement = document.createElement("option");
          vDrinkOptionElement.value = vArrayDrinkList[bIterator].maNuocUong;
          vDrinkOptionElement.text = vArrayDrinkList[bIterator].tenNuocUong;
          vElementSelectDrink.appendChild(vDrinkOptionElement);
        }
      }
      // hàm thu thập thông tin
      function thuThapThongTin(paramOrderObj) {
        var vSelectCoCombo = document.getElementById("select-size");
        var vOptionCoCombo =
          vSelectCoCombo.options[vSelectCoCombo.selectedIndex].text;
        var vInputMaVoucher = document.getElementById("inp-ma-voucher");
        var vInputHoTen = document.getElementById("inp-hoten");
        var vInputSoDienThoai = document.getElementById("inp-so-dien-thoai");
        var vInputLoiNhan = document.getElementById("inp-loi-nhan");
        var vSelectDoUong = document.getElementById("select-drink");
        var vOptionDrink =
          vSelectDoUong.options[vSelectDoUong.selectedIndex].text;
        var vSelectLoaiPizza = document.getElementById("select-pizza");
        var vOptionPizza =
          vSelectLoaiPizza.options[vSelectLoaiPizza.selectedIndex].text;
        var vInputEmail = document.getElementById("inp-email");
        var vInputDiaChi = document.getElementById("inp-dia-chi");

        paramOrderObj.kichCo = vOptionCoCombo;
        paramOrderObj.idVourcher = vInputMaVoucher.value.trim();
        paramOrderObj.hoTen = vInputHoTen.value.trim();
        paramOrderObj.soDienThoai = vInputSoDienThoai.value.trim();
        paramOrderObj.loiNhan = vInputLoiNhan.value.trim();
        paramOrderObj.idLoaiNuocUong = vOptionDrink;
        paramOrderObj.loaiPizza = vOptionPizza;
        paramOrderObj.diaChi = vInputDiaChi.value.trim();
        paramOrderObj.email = vInputEmail.value.trim();
      }
      // ham combo
      function comBo(paramOrderObj) {
        if (paramOrderObj.kichCo == "Nhỏ") {
          paramOrderObj.duongKinh = "20cm";
          (paramOrderObj.soLuongNuoc = "2"),
            (paramOrderObj.salad = "200g"),
            (paramOrderObj.suon = "2"),
            (paramOrderObj.thanhTien = 150000);
        } else if (paramOrderObj.kichCo == "Vừa") {
          paramOrderObj.duongKinh = "25cm";
          (paramOrderObj.soLuongNuoc = "3"),
            (paramOrderObj.salad = "300g"),
            (paramOrderObj.suon = "3"),
            (paramOrderObj.thanhTien = 200000);
        } else if (paramOrderObj.kichCo == "Lớn") {
          paramOrderObj.duongKinh = "30cm";
          (paramOrderObj.soLuongNuoc = "4"),
            (paramOrderObj.salad = "500g"),
            (paramOrderObj.suon = "8"),
            (paramOrderObj.thanhTien = 250000);
        }
      }
      // hàm kiểm tra thông tin
      function kiemTraThongTin(paramOrderObj) {
        if (
          paramOrderObj.coCombo == "Chọn cỡ Combo (Combo size)" ||
          paramOrderObj.hoTen == "" ||
          paramOrderObj.soDienThoai == "" ||
          paramOrderObj.doUong == "Chọn đồ uống" ||
          paramOrderObj.loaiPizza == "Chọn loại pizza" ||
          paramOrderObj.diaChi == ""
        ) {
          alert("các trường không được bỏ trống!");
          return false;
        } else if (checkEmail(paramOrderObj.email) == false) {
          return false;
        }
        return true;
      }
      // hàm kiểm tra email hợp lệ
      function checkEmail(paramEmail) {
        var filter =
          /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
        if (!filter.test(paramEmail)) {
          alert("Hay nhap dia chi email hop le.\nExample@gmail.com");

          return false;
        } else {
          alert("OK roi day, Email nay hop le.");
        }
      }

      // Hàm lấy thông tin combo

      // hàm gọi api để tạo đơn hàng
      function goiApiCreateOrder(paramOrderObj, paramXhttp) {
        var vOrderJson = JSON.stringify(paramOrderObj);
        paramXhttp.open("POST", gBASE_URL + "orders", true);

        paramXhttp.setRequestHeader(
          "Content-Type",
          gUTF8_TEXT_APPLICATION_HEADER
        );
        paramXhttp.send(vOrderJson);
      }
      //ham kiem tra idVoucher
      function kiemTraIdVourcher(paramOrderObj, paramXhttp) {
        goiApiDeCheckIdVourcher(paramOrderObj, paramXhttp);
        if (paramXhttp.status == gREQUEST_STATUS_OK) {
          console.log(paramXhttp.responseText);
        } else {
          console.log("không tồn tại mã giảm giá");
        }
      }
      // goi api de checj id vourcher
      function goiApiDeCheckIdVourcher(paramOrderObj, paramXhttp) {
        paramXhttp.open(
          "GET",
          gBASE_URL + "voucher_detail/" + paramOrderObj.idVourcher,
          false
        );
        paramXhttp.send();
      }

      //
    </script>
  </body>
</html>
